from osv import fields,osv,orm

class base_contact_crm(osv.osv):
    _inherit = 'crm.case'
    _columns = {
                'partner_contact_id': fields.many2one('res.partner.contact', 'Partner Contact'),
                }
    def get_email(self, cr, uid, partner, contact):
        email = ''
        if contact:
            for func in contact.job_ids:
                if func.name.id == partner:
                    return func.email
            if not email and contact.email:
                return contact.email
        addrs = self.pool.get('res.partner').browse(cr, uid, [partner])[0].address
        for addr in addrs:
            if addr.email:
                return addr.email
        return email

    def onchange_partner_id(self, cr, uid, ids, part, email=False):
        if not part:
            return {'value':{'partner_contact_id': False}}
        addr = self.pool.get('res.partner').address_get(cr, uid, [part], ['contact'])
        data={}
        data['partner_contact_id'] = contact = False
        if addr['contact']:
            partner_address = self.pool.get('res.partner.address').browse(cr,uid,addr['contact'])
            if partner_address.job_ids:
                if partner_address.job_ids[0].contact_id:
                    data['partner_contact_id'] = partner_address.job_ids[0].contact_id.id
                    contact = partner_address.job_ids[0].contact_id
        data['email_from'] = self.get_email(cr,uid,part,contact)
        return {'value':data}

    def onchange_contact(self, cr, uid, ids, partner, contact):
        data={}
        contact_rec = self.pool.get('res.partner.contact').browse(cr,uid,[contact])[0]
        data['email_from'] = self.get_email(cr,uid,partner,contact_rec)
        return {'value':data}

base_contact_crm()